searchNodes=[{"doc":"edbg - Erlang/Elixir trace and debug tool edbg is a tty based interface to the Erlang debugger/tracer and the supervisor trees. This module is the main interface to edbg . Note that most of the functions here relates to the debugger functionality. For tracing you only need the functions: fstart/2 , fstop/0 , file/0 , xfile/0 (and possibly some variants of the argument number). For the Supervisor Tree Browser, you only need: suptrees/0 .","ref":"edbg.html","title":"edbg","type":"module"},{"doc":"Attach to the first process found stopped on a break point. Attach to an interpreted process in order to manually control the further execution, inspect variables, etc. When called, you will enter a sort of mini-shell where you can issue a number of commands.","ref":"edbg.html#a/0","title":"edbg.a/0","type":"function"},{"doc":"Attach to the given Pid.","ref":"edbg.html#a/1","title":"edbg.a/1","type":"function"},{"doc":"Attach to the given process: &lt;P0.P1.P2&gt; .","ref":"edbg.html#a/3","title":"edbg.a/3","type":"function"},{"doc":"Attach to the given Pid.","ref":"edbg.html#attach/1","title":"edbg.attach/1","type":"function"},{"doc":"Attach to the given process: &lt;P0.P1.P2&gt; .","ref":"edbg.html#attach/3","title":"edbg.attach/3","type":"function"},{"doc":"Set a break point in 'Mod' at line 'Line'.","ref":"edbg.html#b/2","title":"edbg.b/2","type":"function"},{"doc":"Delete all break points.","ref":"edbg.html#bdel/0","title":"edbg.bdel/0","type":"function"},{"doc":"Delete the break point in 'Mod' on line 'Line'.","ref":"edbg.html#bdel/2","title":"edbg.bdel/2","type":"function"},{"doc":"Disable all break points.","ref":"edbg.html#boff/0","title":"edbg.boff/0","type":"function"},{"doc":"Disable the break point in 'Mod' on line 'Line'.","ref":"edbg.html#boff/2","title":"edbg.boff/2","type":"function"},{"doc":"Disable all break points.","ref":"edbg.html#bon/0","title":"edbg.bon/0","type":"function"},{"doc":"Enable the break point in 'Mod' on line 'Line'.","ref":"edbg.html#bon/2","title":"edbg.bon/2","type":"function"},{"doc":"Display all break points.","ref":"edbg.html#br/0","title":"edbg.br/0","type":"function"},{"doc":"Display all break points for module 'Mod'.","ref":"edbg.html#br/1","title":"edbg.br/1","type":"function"},{"doc":"Set a break point in 'Mod' at line 'Line'.","ref":"edbg.html#break/2","title":"edbg.break/2","type":"function"},{"doc":"Display all break points.","ref":"edbg.html#breaks/0","title":"edbg.breaks/0","type":"function"},{"doc":"Display all break points for module 'Mod'.","ref":"edbg.html#breaks/1","title":"edbg.breaks/1","type":"function"},{"doc":"Continue the execution of the given process 'Pid'.","ref":"edbg.html#c/1","title":"edbg.c/1","type":"function"},{"doc":"Continue the execution of the given process &lt;P0.P1.P2&gt;.","ref":"edbg.html#c/3","title":"edbg.c/3","type":"function"},{"doc":"Continue the execution of the given process 'Pid'.","ref":"edbg.html#continue/1","title":"edbg.continue/1","type":"function"},{"doc":"Continue the execution of the given process &lt;P0.P1.P2&gt;.","ref":"edbg.html#continue/3","title":"edbg.continue/3","type":"function"},{"doc":"Delete the break point in 'Mod' on line 'Line'.","ref":"edbg.html#delete_break/2","title":"edbg.delete_break/2","type":"function"},{"doc":"Delete all break points.","ref":"edbg.html#delete_breaks/0","title":"edbg.delete_breaks/0","type":"function"},{"doc":"Disable the break point in 'Mod' on line 'Line'.","ref":"edbg.html#disable_break/2","title":"edbg.disable_break/2","type":"function"},{"doc":"Disable all break points.","ref":"edbg.html#disable_breaks/0","title":"edbg.disable_breaks/0","type":"function"},{"doc":"Enable the break point in 'Mod' on line 'Line'.","ref":"edbg.html#enable_break/2","title":"edbg.enable_break/2","type":"function"},{"doc":"Disable all break points.","ref":"edbg.html#enable_breaks/0","title":"edbg.enable_breaks/0","type":"function"},{"doc":"Finish execution of a debugged function in process: 'Pid'.","ref":"edbg.html#f/1","title":"edbg.f/1","type":"function"},{"doc":"Finish execution of a debugged function in process: &lt;P0.P1.P2&gt;.","ref":"edbg.html#f/3","title":"edbg.f/3","type":"function"},{"doc":"Display a short help text.","ref":"edbg.html#fhelp/0","title":"edbg.fhelp/0","type":"function"},{"doc":"As 'file/1' but uses the default trace output filename.","ref":"edbg.html#file/0","title":"edbg.file/0","type":"function"},{"doc":"Load the trace output from the file 'Fname'. When the file is loaded, enter the trace list mode.","ref":"edbg.html#file/1","title":"edbg.file/1","type":"function"},{"doc":"Finish execution of a debugged function in process: 'Pid'.","ref":"edbg.html#finish/1","title":"edbg.finish/1","type":"function"},{"doc":"Finish execution of a debugged function in process: &lt;P0.P1.P2&gt;.","ref":"edbg.html#finish/3","title":"edbg.finish/3","type":"function"},{"doc":"Start tracing the process: 'Pid'. A qick way of start tracing a process. The Options are set to be: [ dump_output_eager , send_receive , { max_msgs , 1000000 } ]","ref":"edbg.html#fpid/1","title":"edbg.fpid/1","type":"function"},{"doc":"Start tracing the process: 'Pid'. Start tracing the process. The Options are the same as for the 'fstart/2' function-","ref":"edbg.html#fpid/2","title":"edbg.fpid/2","type":"function"},{"doc":"Start tracing making use of a previously stored configuration. A previous call to 'fstart/2' will store the configuration on disk so that it can be resued when calling this function.","ref":"edbg.html#fstart/0","title":"edbg.fstart/0","type":"function"},{"doc":"Start tracing making use of a previously stored configuration. A previous call to 'fstart/2' will store the configuration on disk so that it can be resued when calling this function.","ref":"edbg.html#fstart/1","title":"edbg.fstart/1","type":"function"},{"doc":"Start tracing to file. 'ModFunList' is a list of module names (atoms) or tuples {ModuleName, FunctionName}. This makes it possible to trace on all functions within a Module, or just a few functions within a Module. 'Opts' is a list of option tuples: {log_file, FileName} : file where to store trace output; default: 'edbg.trace_result' {cfg_file, FileName} : file where to store the config; default: 'ftrace.edbg' {max_msgs, MaxNumOfMsgs} : max number of trace messages; default = 1000 {trace_time, Seconds} : max time to trace; default = 10 seconds {trace_spec, Spec} : see the erlang:trace/3 docs; default = all dump_output_eager : trace output goes to file often dump_output_lazy : trace output goes to file not so often (default) monotonic_ts : show the elapsed monotonic nano seconds send_receive : trace send/receive messages from 'known' pids memory : track the memory usage of the 'known' pids Tracing in an Erlang node is setup by the 'erlang:trace/3' and 'erlang:trace_pattern/3' BIF's. The generated trace output in a production system can quickly produce a staggering amount of data, which easily can swamp the whole system, so that it becomes unusable. It is therefore important to restrict what to trace, the amount of generated trace messages and the maximum time we allow tracing to go on. 'edbg' helps you with this but you can still brake your system if you are careless setting the trace parameters. With the max_msgs and trace_time parameters you can restrict the amount of generated trace messages and running time before stopping the tracing. The trace_spec is also a way of restricting what to trace on. Default is all , but for later OTP versions (&gt; 18.3): processes is available and would be more specific. For more info about this, see the 'erlang:trace/3' documentation. With the dump_output_lazy switch set, trace output goes to file not until the tracer is stopped (e.g by calling the 'file/1' function), or that a limiting filter such as max_msg or trace_time is reached. This is the default. With the dump_output_eager switch set, trace output goes to file often which may be necessary if you run edbg tracing and the system unexpectedly shuts down. With the monotonic_ts switch set, each trace message will have a monotonic timestamp, in nanoseconds, attached to it. This will be displayed in the call graph as the elapsed time counted from the first received trace message. With the send_receive switch set, we will also trace messages sent and received by 'known' pids. By 'known' pids we mean processes that we have seen earlier in a traced call. The reason for this is to avoid beig swamped by all the messages that the trace BIF is sending us. Note that we still may get a lots of messages that will cause the resulting trace file to be large and make the handling of it slower. The display of sent and received messages can be toggled on/off from the trace command prompt, see also the trace examples. With the memory switch set, we will also track the memory usage of the processes that we get trace messages for. The memory size shown is the size in bytes of the process. This includes call stack, heap, and internal structures, as what we get from the process_info(Pid, memory) BIF. NOTE: we run the process_info/2 BIF when we receive the trace message from the BEAM engine so the memory size we present does not exactly represent the state of the process at the creation of the trace message. % Example, trace calls to the foo module, no more than 1000 trace msgs edbg : fstart ( [ foo ] , [ { max_msgs , 1000 } ] ) . % Example, trace all modules in a particular process, % dump the traced output to file often, % no more than 1000 trace msgs. edbg : fstart ( [ ] , [ { trace_spec , Pid } , dump_output_eager , { max_msgs , 1000 } ] ) .","ref":"edbg.html#fstart/2","title":"edbg.fstart/2","type":"function"},{"doc":"Stop tracing and dump the trace output to file.","ref":"edbg.html#fstop/0","title":"edbg.fstop/0","type":"function"},{"doc":"Start interpret the module 'Mod'. With only one argument, you don't set an explicit break point, but you will be able to step into the module while debugging.","ref":"edbg.html#i/1","title":"edbg.i/1","type":"function"},{"doc":"Start interpret module 'Mod' and set a break point at line 'Line'.","ref":"edbg.html#i/2","title":"edbg.i/2","type":"function"},{"doc":"Show all interpreted modules.","ref":"edbg.html#id/0","title":"edbg.id/0","type":"function"},{"doc":"Start interpret module 'Mod' and set a conditional break point. Start interpret module 'Mod' and set a conditional break point in 'Mod' at line 'Line'. The 'Fun/1' as an anonymous function of arity 1 that gets executed each time the break point is passed. When the 'Fun/1' returns 'true' the break point will trigger and the execution will stop, else the execution will continue. The 'Fun/1' takes an argument which will be a list of current Variable bindings; typically it makes use of the function 'int:get_binding(Var, Bindings)' (where 'Var' is an atom denoting a particular variable) to decide if the break point should trigger or not. See the example further below for how to use it. Note that only one interactive trigger function can be used at a time.","ref":"edbg.html#it/3","title":"edbg.it/3","type":"function"},{"doc":"Load (previously) stored break points. Identical to 'load_all_breakpoints/0'.","ref":"edbg.html#lab/0","title":"edbg.lab/0","type":"function"},{"doc":"Load (previously) stored break points. Whenever a break point is set or modified, information is stored on disk in the file 'breakpoints.edbg' . This function will load and set those breakpoints found in this file.","ref":"edbg.html#load_all_breakpoints/0","title":"edbg.load_all_breakpoints/0","type":"function"},{"doc":"As 'mlist/1'.","ref":"edbg.html#ml/1","title":"edbg.ml/1","type":"function"},{"doc":"As 'mlist/2'.","ref":"edbg.html#ml/2","title":"edbg.ml/2","type":"function"},{"doc":"As 'mlist/3'.","ref":"edbg.html#ml/3","title":"edbg.ml/3","type":"function"},{"doc":"List the source code, centered around a break point. The 'mlist/1' can also take a Module as an argument to list the source ode starting from Row 1.","ref":"edbg.html#mlist/1","title":"edbg.mlist/1","type":"function"},{"doc":"List the source code of a 'Module' centered around 'Row'.","ref":"edbg.html#mlist/2","title":"edbg.mlist/2","type":"function"},{"doc":"List the source code of a Module. List the source code of a 'Module', either centered around a triggered break point, or around a given 'Line'. The amount of lines being display around the line is controlled by the 'Contexft' value, which per default is set to '5' (i.e display 5 lines above and below the line). Note that the listing will display the line numbers at the left border of the output where breakpoints are high lighted by a '*' character and the given line as '&gt;'. However, if no line is given, the '&gt;' character will be used to denote where we currently are stopped. The 'mlist/3' can also take a sequence of integers for supplying a 'Pid' when we should center around a break point.","ref":"edbg.html#mlist/3","title":"edbg.mlist/3","type":"function"},{"doc":"Same as 'next/1'.","ref":"edbg.html#n/1","title":"edbg.n/1","type":"function"},{"doc":"Same as 'next/3'.","ref":"edbg.html#n/3","title":"edbg.n/3","type":"function"},{"doc":"Do a 'Next' debug operation of a stopped process: 'Pid'.","ref":"edbg.html#next/1","title":"edbg.next/1","type":"function"},{"doc":"Do a 'Next' debug operation of a stopped process: &gt;P0.P1.P2&lt;.","ref":"edbg.html#next/3","title":"edbg.next/3","type":"function"},{"doc":"Show all interpreted processes.","ref":"edbg.html#pl/0","title":"edbg.pl/0","type":"function"},{"doc":"Show all interpreted processes. Show all interpreted processes and what state there are in. In particular this is useful to see if a process has stopped at a break point. The process identifier ('Pid') displayed in the leftmost column can be used with the 'attach/1' function.","ref":"edbg.html#plist/0","title":"edbg.plist/0","type":"function"},{"doc":"Same as 'step/1'.","ref":"edbg.html#s/1","title":"edbg.s/1","type":"function"},{"doc":"Same as 'step/3'.","ref":"edbg.html#s/3","title":"edbg.s/3","type":"function"},{"doc":"Save all current break points. Identical to 'save_all_breakpoints/0'.","ref":"edbg.html#sab/0","title":"edbg.sab/0","type":"function"},{"doc":"Save all current break points. Whenever a break point is set or modified, information is stored on disk in the file 'breakpoints.edbg' .","ref":"edbg.html#save_all_breakpoints/0","title":"edbg.save_all_breakpoints/0","type":"function"},{"doc":"Do a 'Step' debug operation of a stopped process: 'Pid'.","ref":"edbg.html#step/1","title":"edbg.step/1","type":"function"},{"doc":"Do a 'Step' debug operation of a stopped process: &gt;P0.P1.P2&lt;.","ref":"edbg.html#step/3","title":"edbg.step/3","type":"function"},{"doc":"Enter the Supervisor Tree Browser. See also: edbg_sup_trees .","ref":"edbg.html#suptrees/0","title":"edbg.suptrees/0","type":"function"},{"doc":"As 't/3' but will reuse an existing trigger function.","ref":"edbg.html#t/2","title":"edbg.t/2","type":"function"},{"doc":"As 'it/3' but assumes 'Mod' already is interpreted.","ref":"edbg.html#t/3","title":"edbg.t/3","type":"function"},{"doc":"As 'file/0' but hint that Elixir code is traced.","ref":"edbg.html#xfile/0","title":"edbg.xfile/0","type":"function"},{"doc":"As 'file/1' but hint that Elixir code is traced.","ref":"edbg.html#xfile/1","title":"edbg.xfile/1","type":"function"},{"doc":"Explore all supervision trees Display all supervisors we have found in our system. Each line has a number that can be referenced, where the S mean that the process is a supervisor. ( abc @ ozzy ) 1 &gt; edbg : suptrees ( ) . 1 : S kernel_safe_sup &lt; 0.74 . 0 &gt; [ ] 2 : S kernel_sup &lt; 0.49 . 0 &gt; [ erl_distribution ] 23 : S logger_sup &lt; 0.75 . 0 &gt; [ ] 27 : S net_sup &lt; 0.57 . 0 &gt; [ ] ( h ) elp e ( x ) pand [ &lt; N &gt; ] ( s ) hrink [ &lt; N &gt; ] ( p ) rocess info [ &lt; N &gt; [ &lt; M &gt; ] ] ( b ) acktrace [ &lt; N &gt; [ &lt; M &gt; ] ] ( r ) efresh ( q ) uit Note the short help text; we will now go through what those commands does. First let us expand supervisor 23 to see its children. Note the indentation and the G which mean that the process is a gen_server process, where W mean some other worker process. suptrees &gt; x 23 1 : S kernel_safe_sup &lt; 0.74 . 0 &gt; [ ] 2 : S kernel_sup &lt; 0.49 . 0 &gt; [ erl_distribution ] 23 : S logger_sup &lt; 0.75 . 0 &gt; [ ] 24 : G default &lt; 0.79 . 0 &gt; [ logger_h_common ] 25 : G logger_proxy &lt; 0.77 . 0 &gt; [ logger_proxy ] 26 : G logger_handler_watcher &lt; 0.76 . 0 &gt; [ logger_handler_watcher ] 27 : S net_sup &lt; 0.57 . 0 &gt; [ ] Print the process-info of worker 24 Note the list of linked processes. suptrees &gt; p 24 == = Process Info : &lt; 0.79 . 0 &gt; [ { registered_name , logger_std_h_default } , { current_function , { gen_server , loop , 7 } } , { initial_call , { proc_lib , init_p , 5 } } , { status , waiting } , { message_queue_len , 0 } , { links , [ &lt; 0.75 . 0 &gt; , &lt; 0.80 . 0 &gt; ] } , { dictionary , [ { &#39; $a ncest . . . snip . . . We can also print the process info of any linked processes. Let us print the process-info of the second process in the links list. suptrees &gt; p 24 2 == = Process Info : &lt; 0.80 . 0 &gt; [ { current_function , { logger_std_h , file_ctrl_loop , 1 } } , { initial_call , { erlang , apply , 2 } } , { status , waiting } , { message_queue_len , 0 } , { links , [ &lt; 0.79 . 0 &gt; ] } , { diction . . . . . snip . . . We can continue like this... suptrees &gt; p 24 2 1 == = Process Info : &lt; 0.79 . 0 &gt; [ { registered_name , logger_std_h_default } , { current_function , { gen_server , loop , 7 } } , { initial_call , { proc_lib , init_p , 5 } } , { status , waiting } , { message_queue_len , 0 } , { links , [ &lt; 0.75 . 0 &gt; , &lt; 0.80 . 0 &gt; ] } , { dictionary , . . . . snip . . . We can also print the process backtrace in the same way: suptrees &gt; b 24 2 . . . snip . . . We can also setup a monitor for a process: suptrees &gt; m 161 2 Monitoring : &lt; 0.343 . 0 &gt; . . . do stuff , crunch . . . Monitor got DOWN from : &lt; 0.343 . 0 &gt; , Reason : shutdown We can print the state of a gen_server. Let say we have the following: 1 : S kernel_safe_sup &lt; 0.74 . 0 &gt; [ ] 2 : S kernel_sup &lt; 0.49 . 0 &gt; [ erl_distribution ] 3 : S logger_sup &lt; 0.75 . 0 &gt; [ ] 4 : G default &lt; 0.79 . 0 &gt; [ logger_h_common ] . . . snip . . . Now print the state of the &lt;0.79.0&gt; gen_server process. suptrees &gt; g 4 Process State : &lt; 0.79 . 0 &gt; \#{ burst_limit_enable =&gt; true , burst_limit_max_count =&gt; 500 , burst_limit_window_time =&gt; 1000 , burst_msg_count =&gt; 0 , . . . snip . . You can start tracing on a process like this: suptrees &gt; ts 4 You stop the tracing like this: suptrees &gt; te You show the trace output (like with edbg:file/0 ) like this: suptrees &gt; tf","ref":"edbg_sup_trees.html","title":"edbg_sup_trees","type":"module"},{"doc":"Enter the Supervisor Tree Browser.","ref":"edbg_sup_trees.html#start/0","title":"edbg_sup_trees.start/0","type":"function"},{"doc":"The edbg tracer. The function edbg:fstart/2 takes one argument containing the list of modules we want to trace, and a second argument containing various options. The trace output will be stored on file. So in the example below we want to trace on three modules: yaws_server, yaws, yaws_config, from the Yaws webserver. With the max_msgs option we restrict the allowed number of trace messages to 10000. 1 &gt; edbg : fstart ( [ yaws_server , yaws , yaws_config ] , [ { max_msgs , 10000 } ] ) . ok Now run some traffic toward yaws and when done, stop the tracing: 2 &gt; edbg : fstop ( ) . ok Here we rely on using the default filename for storing the trace output, hence we don't have to specify it here when loading the trace info to be displayed. 3 &gt; edbg : file ( ) . ( h ) elp ( a ) t [ &lt; N &gt; ] ( d ) own ( u ) p ( t ) op ( b ) ottom ( s ) how &lt; N &gt; [ &lt; ArgN &gt; ] ( r ) etval &lt; N &gt; ra ( w ) &lt; N &gt; ( pr ) etty print record &lt; N &gt; &lt; ArgN &gt; ( f ) ind &lt; RegExp &gt; [ &lt; ArgN &gt; &lt; ArgRegExp &gt; ] ( fr ) &lt; RetRegExp &gt; ( on ) / ( off ) send_receive | memory ( p ) agesize &lt; N &gt; ( q ) uit ( set ) &lt; Var &gt; &lt; N &gt; [ &lt; ArgN &gt; ] ( let ) &lt; Var &gt; &lt; Expr &gt; ( eval ) &lt; Expr &gt; ( xall / xnall ) &lt; Mod &gt; As can be seen, we first get a compact help text showing what commands we can use. Then follows the beginning of the trace output. Each line is prefixed with a number that we use for reference. The indentation shows the depth of the call chain. 0 : &lt; 0.255 . 0 &gt; yaws_server : gserv_loop / 4 1 : &lt; 0.258 . 0 &gt; yaws_server : gserv_loop / 4 2 : &lt; 0.233 . 0 &gt; yaws : month / 1 4 : &lt; 0.259 . 0 &gt; yaws_server : peername / 2 6 : &lt; 0.258 . 0 &gt; yaws_server : close_accepted_if_max / 2 8 : &lt; 0.258 . 0 &gt; yaws_server : acceptor / 1 10 : &lt; 0.258 . 0 &gt; yaws_server : gserv_loop / 4 11 : &lt; 0.281 . 0 &gt; yaws_server : acceptor0 / 2 12 : &lt; 0.281 . 0 &gt; yaws_server : do_accept / 1 . . . snip . . . As you can see, we get a pretty output where we can follow the chain of execution without drowning in output which would be the case if we should have displayed the contents of all the arguments to the functions. Instead, we can now inspect a particular call of interest, let's say line 4; we use the (s)how command to display the function clause heads in order to help us decide which argument to inspect. tlist &gt; s 4 Call : yaws_server : peername / 2 -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - peername ( CliSock , ssl ) -&gt; peername ( CliSock , nossl ) -&gt; -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - To show what the second argument contained, we add 2 to the show command: tlist &gt; s 4 2 Call : yaws_server : peername / 2 , argument 2 : -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - nossl We can also see what the function returned: tlist &gt; r 4 Call : yaws_server : peername / 2 , return value : -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - { { 127 , 0 , 0 , 1 } , 35871 } To display (again) the function call chain, you use the a(t) command. With no arguments it will just re-display the trace output. If you want to go to a particular line you just give that as an argument. Example, go to line 10 in the example above: tlist &gt; a 10 10 : &lt; 0.258 . 0 &gt; yaws_server : gserv_loop / 4 11 : &lt; 0.281 . 0 &gt; yaws_server : acceptor0 / 2 12 : &lt; 0.281 . 0 &gt; yaws_server : do_accept / 1 13 : &lt; 0.259 . 0 &gt; yaws_server : aloop / 4 . . . snip . . . To change the number of lines shown of the trace output. Set it with the p(age) command. Example, display (roughly) 50 lines: tlist &gt; p 50 The amount of trace output can be huge so we can search for a particular function call that we are interested in. Note that you can specify a RegExp for searching among the Mod:Fun calls. tlist &gt; f yaws : decode_b 32 : &lt; 0.537 . 0 &gt; yaws : decode_base64 / 1 33 : &lt; 0.537 . 0 &gt; yaws : decode_base64 / 2 34 : &lt; 0.537 . 0 &gt; yaws : d / 1 . . . snip . . . We can also search in a particular argument of a particular function call. Here the second argument of yaws:setopts should contain the string: 'packet_size': tlist &gt; f yaws : setopts 2 packet_size 22 : &lt; 0.537 . 0 &gt; yaws : setopts / 3 24 : &lt; 0.537 . 0 &gt; yaws : do_recv / 3 26 : &lt; 0.537 . 0 &gt; yaws : http_collect_headers / 5 . . . snip . . . We can now verify that it found it: tlist &gt; s 22 2 Call : yaws : setopts / 3 , argument 2 : -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - [ { packet , httph } , { packet_size , 16384 } ] To search among the return values we use the 'fr' command: tlist &gt; fr GET 184 : &lt; 0.537 . 0 &gt; yaws : make_allow_header / 1 187 : &lt; 0.537 . 0 &gt; yaws_server : deliver_accumulated / 1 188 : &lt; 0.537 . 0 &gt; yaws : outh_get_content_encoding / 0 190 : &lt; 0.537 . 0 &gt; yaws : outh_set_content_encoding / 1 . . . snip . . . We can now verify that it found it: tlist &gt; r 184 Call : yaws : make_allow_header / 1 , return value : -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - [ &quot;Allow: GET, POST, OPTIONS, HEAD\\r\\n&quot; ] To see more examples visit the edbg wiki at: https://github.com/etnt/edbg/wiki/Tracing","ref":"edbg_tracer.html","title":"edbg_tracer","type":"module"},{"doc":"","ref":"edbg_utils.html","title":"edbg_utils","type":"module"},{"doc":"A tty based interface to the Erlang debugger/tracer and supervisor tree browser. The purpose of edbg is to provide a simple and intuitive interface to the Erlang debugger and the builtin tracing functionality. Especially when tracing in the BEAM machine, it is easy to be swamped by all the trace messages that are generated. edbg will avoid that by presenting a clean function call graph, indented according to the call depth. edbg provide means to search for a particular function call, or an arbitrary string among the function arguments or return values; you may then inspect the content of only those arguments you are interested in. edbg now also support Elixir ! Example: The call graph 10 : &lt; 0.258 . 0 &gt; yaws_server : gserv_loop / 4 11 : &lt; 0.281 . 0 &gt; yaws_server : acceptor0 / 2 12 : &lt; 0.281 . 0 &gt; yaws_server : do_accept / 1 13 : &lt; 0.259 . 0 &gt; yaws_server : aloop / 4 Example: Display content of a function call argument tlist &gt; pr 177 2 Call : yaws_server : handle_request / 3 , argument 2 : -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - # arg { clisock = # Port &lt; 0.6886 &gt; , client_ip_port = { { 127 , 0 , 0 , 1 } , 35871 } , headers = # headers { connection = undefined , accept = &quot;*/*&quot; , host = &quot;localhost:8008&quot; , if_modified_since = undefined , if_match = undefined , if_none_match = undefined , . . . snip . . . edbg consists of three main parts: Tracing Supervision Tree Browser Debugger If you don't like GUI's, edbg may be your cup of tea. Or, for example, you work from home but still want to debug your code at your work desktop without the hassle of forwarding a GUI, then edbg is perfect. You can see examples of how to use edbg in the wiki pages.","ref":"readme.html","title":"E D B G","type":"extras"},{"doc":"Run : make Add : code : add_path ( &quot;YOUR-PATH-HERE/edbg/_build/default/lib/edbg/ebin&quot; ) . Add : code : add_path ( &quot;YOUR-PATH-HERE/edbg/_build/default/lib/pp_record/ebin&quot; ) . to your ~ / . erlang file . If you don't fancy rebar and favour plain Make + Erlc then: Run : make old Add : code : add_path ( &quot;YOUR-PATH-HERE/edbg/ebin&quot; ) . Add : code : add_path ( &quot;YOUR-PATH-HERE/edbg/deps/pp_record/ebin&quot; ) . to your ~ / . erlang file . NOTE: The coloring code makes use of 'maps', so in case of an older Erlang system where 'maps' isn't supported, you must compile the code as: env USE_COLORS = false make","ref":"readme.html#install","title":"E D B G - INSTALL","type":"extras"},{"doc":"The built in tracing functionality of the BEAM is great and there are a couple of tools that builds upon it. What differentiates edbg is two things; first it runs in the terminal with all the pros (and cons) that brings; second it try to avoid drowning you in trace output. Trace output can be massive and in fact sink your whole BEAM node. edbg protects you from that by letting you restrict the amount of trace messages generated and/or the amount of time the tracing will run for. The output will then be presented in structured way to let you focus on what you are looking for, without having to wade through mountains of non relevant data.","ref":"readme.html#tracing","title":"E D B G - Tracing","type":"extras"},{"doc":"By invoking the edbg:suptrees/0 function from the Erlang shell, you will enter the supervision tree browser; a way to quickly get an overview of your system by listing the running supervisors. The browser makes it possible to browse through the tree of supervisors as well as any linked processes. At any point, a process can have its (default) process-info data printed as well as its backtrace. If the worker process is of type gen_server, gen_event or gen_statem, it is possible to pretty-print the State of the callback module that the worker process is maintaining. It is also possible to setup a process monitor on any process in order to get a notification printed if the process should terminate. Note that the (edbg) tracing is built-in; i.e you can start tracing on any process you can access from the supervision browser. This will trace all modules that are executing within the process as well as any messages sent/received from/to the process.","ref":"readme.html#supervisor-tree-browser","title":"E D B G - Supervisor Tree Browser","type":"extras"},{"doc":"With the edbg debugger interface you can make use of the Erlang debugger in a similar way as with the GUI version. You can set break points and then attach to a process that has stopped at a break point. From there you can single step and do the usual debugger operations. What differentiates edbg is the fact that you are running in a terminal.","ref":"readme.html#debugger","title":"E D B G - Debugger","type":"extras"},{"doc":"Copyright 2017 Torbjorn Tornkvist Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]